// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

part of omnibuild;

/// Mustache template for omnibuild code.
const omnibuildTemplateSource = '''
{{# fn.rmLf }}{{# fn.normalComment }}{{{ data.copyright }}}{{/ fn.normalComment }}{{/ fn.rmLf }}

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of {{ data.library }};

{{# fn.rmLf }}{{# fn.docComment }}{{{ data.description }}}{{/ fn.docComment }}{{/ fn.rmLf }}
{{# data.messages }}

{{# fn.rmLf }}{{# fn.docComment }}{{{ documentation }}}{{/ fn.docComment }}
{{/ fn.rmLf }}
class {{ name }} extends {{ superClass }} {
  /// omnibusId
  static const id = '{{{ omnibusId }}}';

  {{# properties }}
{{# fn.indent }}{{# fn.docComment }}{{{ documentation }}}{{/ fn.docComment }}{{/ fn.indent }}  final {{{ type }}} {{ name }};

  {{/ properties }}
  /// Constructor
  {{ name }}({{# fn.constructorArgs }}{{/ fn.constructorArgs }})
      : super(id);

  /// Construct from passive data structure.
  factory {{ name }}.fromPds(final Map<String, dynamic> pds) {
    {{# properties }}
    {{{ type }}} {{ name }};
    {{/ properties }}
    {{# properties }}

    // Read {{ name }}.
    if (pds.containsKey('{{ name }}'){{# fn.pdsCast }}{{/ fn.pdsCast }}) {
      {{ name }} = {{# fn.reverseConstruct }}pds['{{ name }}']{{/ fn.reverseConstruct }};
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property '{{ name }}'");
    }
    {{/ properties }}

    return new {{ name }}({{# fn.constructorCall }}{{/ fn.constructorCall }});
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {{# fn.toPdsMap }}{{/ fn.toPdsMap }};
  }
}
{{# fn.onlyIfEventOrRequest }}

/// Message handler for {{ name }}
class {{ name }}Handler extends {{ superClass }}Handler {
  /// Callback
  final {{ superClass }}Callback<{{ name }}> _callback;

  {{# filter }}
{{# fn.indent }}{{# fn.docComment }}{{{ documentation }}}{{/ fn.docComment }}{{/ fn.indent }}  final {{{ type }}} {{ name }};

  {{/ filter }}
  /// Constructor
  {{ name }}Handler(this._callback, StateData state{{# fn.handlerConstructArgs }}{{/ fn.handlerConstructArgs }})
      : super({{ name }}.id, state);

  /// Process incoming message.
  Future<List<{{# fn.handlerCbReturn }}{{/ fn.handlerCbReturn }}>> process({{ superClass }} data) async {
    {{ name }} message = data is {{ name }}
        ? data
        : new {{ name }}.fromPds(data.toPds());

    {{# fn.handlerRunCb  }}{{/ fn.handlerRunCb }}
  }
}
{{/ fn.onlyIfEventOrRequest }}
{{# fn.onlyIfResponse }}

/// Create {{ name }} Stream from the given responses.
Stream<{{ name }}> stream{{ name }}(OmnibusResponses responses) {
  return responses.stream(
          {{ name }}.id,
          (OmnibusResponse data) =>
              data is {{ name }} ? data : new {{ name }}.fromPds(data.toPds()))
      as Stream<{{ name }}>;
}
{{/ fn.onlyIfResponse }}
{{/ data.messages }}
''';

var _omnibuildTemplate = new Template(omnibuildTemplateSource);
