// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibuild.test.message_library;

class DfltStrings extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.DfltStrings';

  final String simpleString;

  final String stringWithSingleQuotes;

  final String singleLineStringMixedQuotes;

  final String stringLiteralSimple;

  final String stringLiteralWithTripleSingleQuote;

  /// Constructor
  DfltStrings(
      [this.simpleString = 'Hello World!',
      this.stringWithSingleQuotes = "Foo's bar",
      this.singleLineStringMixedQuotes = 'Herman\'s car reads: "Hello world!"',
      this.stringLiteralSimple = '''Hi there,
This is a multiline message.
''',
      this.stringLiteralWithTripleSingleQuote = '''Hi there,
In Dart literal strings look like this:
\'\'\'Herman\'s car reads: "Hello world!"\'\'\'
'''])
      : super(id);

  /// Construct from passive data structure.
  factory DfltStrings.fromPds(final Map<String, dynamic> pds) {
    String simpleString;
    String stringWithSingleQuotes;
    String singleLineStringMixedQuotes;
    String stringLiteralSimple;
    String stringLiteralWithTripleSingleQuote;

    // Read simpleString.
    if (pds.containsKey('simpleString') && pds['simpleString'] is String) {
      simpleString = pds['simpleString'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'simpleString'");
    }

    // Read stringWithSingleQuotes.
    if (pds.containsKey('stringWithSingleQuotes') &&
        pds['stringWithSingleQuotes'] is String) {
      stringWithSingleQuotes = pds['stringWithSingleQuotes'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'stringWithSingleQuotes'");
    }

    // Read singleLineStringMixedQuotes.
    if (pds.containsKey('singleLineStringMixedQuotes') &&
        pds['singleLineStringMixedQuotes'] is String) {
      singleLineStringMixedQuotes =
          pds['singleLineStringMixedQuotes'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'singleLineStringMixedQuotes'");
    }

    // Read stringLiteralSimple.
    if (pds.containsKey('stringLiteralSimple') &&
        pds['stringLiteralSimple'] is String) {
      stringLiteralSimple = pds['stringLiteralSimple'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'stringLiteralSimple'");
    }

    // Read stringLiteralWithTripleSingleQuote.
    if (pds.containsKey('stringLiteralWithTripleSingleQuote') &&
        pds['stringLiteralWithTripleSingleQuote'] is String) {
      stringLiteralWithTripleSingleQuote =
          pds['stringLiteralWithTripleSingleQuote'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'stringLiteralWithTripleSingleQuote'");
    }

    return new DfltStrings(
        simpleString,
        stringWithSingleQuotes,
        singleLineStringMixedQuotes,
        stringLiteralSimple,
        stringLiteralWithTripleSingleQuote);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {
      'simpleString': simpleString,
      'stringWithSingleQuotes': stringWithSingleQuotes,
      'singleLineStringMixedQuotes': singleLineStringMixedQuotes,
      'stringLiteralSimple': stringLiteralSimple,
      'stringLiteralWithTripleSingleQuote': stringLiteralWithTripleSingleQuote
    };
  }
}

/// Message handler for DfltStrings
class DfltStringsHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<DfltStrings> _callback;

  /// Constructor
  DfltStringsHandler(this._callback, StateData state)
      : super(DfltStrings.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    DfltStrings message =
        data is DfltStrings ? data : new DfltStrings.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

class DfltNamed extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.DfltNamed';

  final String namedString;

  final List<int> namedList;

  final Map<String, int> namedMap;

  final MyDateTime namedObject;

  /// Constructor
  DfltNamed(
      {this.namedString: '',
      this.namedList: const [],
      this.namedMap: const {},
      this.namedObject: null})
      : super(id);

  /// Construct from passive data structure.
  factory DfltNamed.fromPds(final Map<String, dynamic> pds) {
    String namedString;
    List<int> namedList;
    Map<String, int> namedMap;
    MyDateTime namedObject;

    // Read namedString.
    if (pds.containsKey('namedString') && pds['namedString'] is String) {
      namedString = pds['namedString'] as String;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'namedString'");
    }

    // Read namedList.
    if (pds.containsKey('namedList') && pds['namedList'] is List) {
      namedList = new List<int>.from(pds['namedList']);
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'namedList'");
    }

    // Read namedMap.
    if (pds.containsKey('namedMap') && pds['namedMap'] is Map) {
      namedMap = new Map<String, int>.from(pds['namedMap']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'namedMap'");
    }

    // Read namedObject.
    if (pds.containsKey('namedObject') && pds['namedObject'] is String) {
      namedObject = new MyDateTime.fromPds(pds['namedObject']);
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'namedObject'");
    }

    return new DfltNamed(
        namedString: namedString,
        namedList: namedList,
        namedMap: namedMap,
        namedObject: namedObject);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {
      'namedString': namedString,
      'namedList': namedList,
      'namedMap': namedMap,
      'namedObject': namedObject.toPds()
    };
  }
}

/// Message handler for DfltNamed
class DfltNamedHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<DfltNamed> _callback;

  /// Constructor
  DfltNamedHandler(this._callback, StateData state)
      : super(DfltNamed.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    DfltNamed message =
        data is DfltNamed ? data : new DfltNamed.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

class ExoticDefaults extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.ExoticDefaults';

  final List<int> defaultedList;

  final Set<List<Set<int>>> defaultedSet;

  final Map<String, int> defaultedMap;

  final Point defaultedConstructor;

  /// Constructor
  ExoticDefaults(this.defaultedSet,
      [this.defaultedList = const [0, 2, 4, 6, 8],
      this.defaultedMap = const {'a': 0, 'b': 1, 'c': 2},
      this.defaultedConstructor = const Point(1, 2)])
      : super(id);

  /// Construct from passive data structure.
  factory ExoticDefaults.fromPds(final Map<String, dynamic> pds) {
    List<int> defaultedList;
    Set<List<Set<int>>> defaultedSet;
    Map<String, int> defaultedMap;
    Point defaultedConstructor;

    // Read defaultedList.
    if (pds.containsKey('defaultedList') && pds['defaultedList'] is List) {
      defaultedList = new List<int>.from(pds['defaultedList']);
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'defaultedList'");
    }

    // Read defaultedSet.
    if (pds.containsKey('defaultedSet') && pds['defaultedSet'] is List) {
      defaultedSet = pdsToSet(
              pds['defaultedSet'],
              (List<List<int>> item) =>
                  pdsToList(item, (List<int> item) => new Set<int>.from(item)))
          as Set<List<Set<int>>>;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'defaultedSet'");
    }

    // Read defaultedMap.
    if (pds.containsKey('defaultedMap') && pds['defaultedMap'] is Map) {
      defaultedMap = new Map<String, int>.from(pds['defaultedMap']);
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'defaultedMap'");
    }

    // Read defaultedConstructor.
    if (pds.containsKey('defaultedConstructor') &&
        pds['defaultedConstructor'] is List) {
      defaultedConstructor =
          new Point.fromPds(new List<int>.from(pds['defaultedConstructor']));
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'defaultedConstructor'");
    }

    return new ExoticDefaults(
        defaultedSet, defaultedList, defaultedMap, defaultedConstructor);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {
      'defaultedList': defaultedList,
      'defaultedSet': pdsFromSet(defaultedSet),
      'defaultedMap': defaultedMap,
      'defaultedConstructor': defaultedConstructor.toPds()
    };
  }
}

/// Message handler for ExoticDefaults
class ExoticDefaultsHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<ExoticDefaults> _callback;

  /// Constructor
  ExoticDefaultsHandler(this._callback, StateData state)
      : super(ExoticDefaults.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    ExoticDefaults message = data is ExoticDefaults
        ? data
        : new ExoticDefaults.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}
