// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

/// This is actually a dummy library that allows the Dart analyzer to link
/// the right classes to the generated messages code in this directory.
library omnibuild.test.message_library;

import 'dart:async';

import 'package:omnibus/omnibus.dart';
import 'package:passive_data/passive_data.dart';

part 'readme.v0.dart';
part 'pure_types.v0.dart';
part 'dflt_values.v0.dart';

/// Object with const constructor
class Point {
  /// Variables
  final int x, y;

  /// Constructor
  const Point(this.x, this.y);

  /// Reverse constructor
  factory Point.fromPds(List<int> pds) {
    return new Point(pds[0], pds[1]);
  }

  /// Generate PDS.
  List<int> toPds() {
    return [x, y];
  }
}

/// DateTime extended with fromPds
class MyDateTime extends DateTime {
  factory MyDateTime.fromPds(String pds) {
    return DateTime.parse(pds);
  }
  String toPds() => toIso8601String();
}

/// Enumeration that is used in the README.md example
enum ImpactFactor { low, medium, high }
