// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibuild.test.message_library;

class ImpureMessage extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibuild.v0.ImpureMessage';

  final List<int> pureList;

  final List<List<Point>> impureList;

  final Map<int, String> intMap;

  /// Constructor
  ImpureMessage(this.pureList, this.impureList, this.intMap) : super(id);

  /// Construct from passive data structure.
  factory ImpureMessage.fromPds(final Map<String, dynamic> pds) {
    List<int> pureList;
    List<List<Point>> impureList;
    Map<int, String> intMap;

    // Read pureList.
    if (pds.containsKey('pureList') && pds['pureList'] is List) {
      pureList = new List<int>.from(pds['pureList']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureList'");
    }

    // Read impureList.
    if (pds.containsKey('impureList') && pds['impureList'] is List) {
      impureList = pdsToList(
              pds['impureList'],
              (List<List<int>> item) => pdsToList(
                  item,
                  (List<int> item) =>
                      new Point.fromPds(new List<int>.from(item))))
          as List<List<Point>>;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'impureList'");
    }

    // Read intMap.
    if (pds.containsKey('intMap') && pds['intMap'] is Map) {
      intMap = pdsToIntMap(pds['intMap'] as Map<String, dynamic>)
          as Map<int, String>;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'intMap'");
    }

    return new ImpureMessage(pureList, impureList, intMap);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {
      'pureList': pureList,
      'impureList': pdsFromList(impureList),
      'intMap': pdsFromMap(intMap)
    };
  }
}

/// Message handler for ImpureMessage
class ImpureMessageHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<ImpureMessage> _callback;

  /// Constructor
  ImpureMessageHandler(this._callback, StateData state)
      : super(ImpureMessage.id, state);

  /// Process incoming message.
  Future<List<Future<OmnibusResponse>>> process(OmnibusRequest data) async {
    ImpureMessage message =
        data is ImpureMessage ? data : new ImpureMessage.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

class PureMessage extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibuild.v0.PureMessage';

  final List<int> pureList;

  final Map<String, List<Map<String, int>>> pureMap;

  /// Constructor
  PureMessage(this.pureList, this.pureMap) : super(id);

  /// Construct from passive data structure.
  factory PureMessage.fromPds(final Map<String, dynamic> pds) {
    List<int> pureList;
    Map<String, List<Map<String, int>>> pureMap;

    // Read pureList.
    if (pds.containsKey('pureList') && pds['pureList'] is List) {
      pureList = new List<int>.from(pds['pureList']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureList'");
    }

    // Read pureMap.
    if (pds.containsKey('pureMap') && pds['pureMap'] is Map) {
      pureMap = pdsToStringMap(
              pds['pureMap'] as Map<String, dynamic>,
              (List<Map<String, int>> item) => pdsToList(item,
                  (Map<String, int> item) => new Map<String, int>.from(item)))
          as Map<String, List<Map<String, int>>>;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureMap'");
    }

    return new PureMessage(pureList, pureMap);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'pureList': pureList, 'pureMap': pureMap};
  }
}

/// Create PureMessage Stream from the given responses.
Stream<PureMessage> streamPureMessage(OmnibusResponses responses) {
  return responses.stream(
      PureMessage.id,
      (OmnibusResponse data) => data is PureMessage
          ? data
          : new PureMessage.fromPds(data.toPds())) as Stream<PureMessage>;
}
