// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibuild.test.message_library;

/// General description of what the messages in this file do and in which
/// scenarios they should be used.

/// Documentation
class MyMessage extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.MyMessage';

  /// Documentation
  final ImpactFactor impactFactor;

  /// Constructor
  MyMessage({this.impactFactor: ImpactFactor.high}) : super(id);

  /// Construct from passive data structure.
  factory MyMessage.fromPds(final Map<String, dynamic> pds) {
    ImpactFactor impactFactor;

    // Read impactFactor.
    if (pds.containsKey('impactFactor') && pds['impactFactor'] is int) {
      impactFactor = ImpactFactor.values[pds['impactFactor']];
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'impactFactor'");
    }

    return new MyMessage(impactFactor: impactFactor);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'impactFactor': impactFactor.index};
  }
}

/// Message handler for MyMessage
class MyMessageHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<MyMessage> _callback;

  /// Documentation
  final ImpactFactor impactFactor;

  /// Constructor
  MyMessageHandler(this._callback, StateData state, {this.impactFactor: null})
      : super(MyMessage.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    MyMessage message =
        data is MyMessage ? data : new MyMessage.fromPds(data.toPds());

    if ((impactFactor == null || impactFactor == message.impactFactor)) {
      return [_callback(message, state)];
    } else {
      return [];
    }
  }
}

class MyResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibuild.v0.MyResponse';

  /// Constructor
  MyResponse() : super(id);

  /// Construct from passive data structure.
  factory MyResponse.fromPds(final Map<String, dynamic> pds) {
    return new MyResponse();
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {};
  }
}

/// Create MyResponse Stream from the given responses.
Stream<MyResponse> streamMyResponse(OmnibusResponses responses) {
  return responses.stream(
          MyResponse.id,
          (OmnibusResponse data) =>
              data is MyResponse ? data : new MyResponse.fromPds(data.toPds()))
      as Stream<MyResponse>;
}
