// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library omnibuild.test.e2e_test;

import 'dart:io';

import 'package:test/test.dart';
import 'package:omnibuild/omnibuild.dart';

void main() {
  test('Test example from README.md', () {
    final yamlData = new File('test/data/readme.v0.yaml').readAsStringSync();
    final expected = new File('test/data/readme.v0.dart').readAsStringSync();
    var spec = new OmnibuildSpecFile.fromYaml(yamlData, 0, 'omnibuild');
    expect(spec.generateCode(), equals(expected));
  });

  test('Test various Map and List types', () {
    final yamlData =
        new File('test/data/pure_types.v0.yaml').readAsStringSync();
    final expected =
        new File('test/data/pure_types.v0.dart').readAsStringSync();
    var spec = new OmnibuildSpecFile.fromYaml(yamlData, 0, 'omnibuild');
    expect(spec.generateCode(), equals(expected));
  });

  test('Test default value types', () {
    final yamlData =
        new File('test/data/dflt_values.v0.yaml').readAsStringSync();
    final expected =
        new File('test/data/dflt_values.v0.dart').readAsStringSync();
    var spec = new OmnibuildSpecFile.fromYaml(yamlData, 0, 'omnibuild');
    expect(spec.generateCode(), equals(expected));
  });
}
