// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library omnibuild.test.parse_test;

import 'package:test/test.dart';
import 'package:omnibuild/omnibuild.dart';

void main() {
  test('Test impure Map without valid PDS type', () {
    expect(() {
      new OmnibuildSpecFile.fromYaml(
          '''
messages:
- name: Message
  type: event
  properties:
  - name: ImpureMap
    type: Map<String, Point>
''',
          0,
          'omnibuild');
    }, throwsArgumentError);
  });

  test('Test String type for enumeration', () {
    expect(() {
      new OmnibuildSpecFile.fromYaml(
          '''
messages:
- name: Message
  type: event
  properties:
  - name: Enumeration
    type: enum Enumeration
    data: String
''',
          0,
          'omnibuild');
    }, throwsArgumentError);
  });

  test('Test incompatible PDS type', () {
    expect(() {
      new OmnibuildSpecFile.fromYaml(
          '''
messages:
- name: Message
  type: event
  properties:
  - name: PureMap
    type: Map<String, List<int>>
    data: Map<String, Int8List>
''',
          0,
          'omnibuild');
    }, throwsArgumentError);
  });
}
